
const modeRotate=0;
const modeZoom=1;
const modePan=2;
var mousemode=modeRotate;

var cube_prevonload=window.onload;

window.onload = cube_onload;


var usewidth=600;
var useheight=930;
var request = new Array();

function cube_onload()
{
  if (cube_prevonload)
  {
    cube_prevonload();
  }

  var vals=document.location.search.substr(1).split("&");
  for (i in vals) 
  {
    vals[i] = vals[i].replace(/\+/g, " ").split("=");
    request[unescape(vals[i][0])] = unescape(vals[i][1]);
  }

  var square=document.getElementById('offscreen-square');
  if (square)
  {
    usewidth=square.clientWidth;
    useheight=square.clientHeight;
  }

    usewidth=window.innerWidth;
    useheight=window.innerHeight;



  newRenderCanvas();

  changeView(); // renderScene();

  init();
  renderer.render(scene, camera);

}

var scene = null;
var camera = null;
var renderer = null;
var context=null;

/*
var materialLines = null;
var materialFloor = null;
var materialFaces = null;
*/
var sceneGroup = null;

function newRenderCanvas()
{
  scene = new THREE.Scene();
  camera = new THREE.PerspectiveCamera( 45, (1.0*usewidth)/useheight, 0.1, 1000 );
  renderer = new THREE.WebGLRenderer( { antialias: true } );
  renderer.setClearColor(0xffffff,1);
  renderer.setSize( usewidth, useheight , false);
  document.body.appendChild( renderer.domElement );

  context=renderer.domElement.getContext("webgl");
/*
  materialLines = new THREE.LineBasicMaterial( {
	  color: 0x000000,
	  linewidth: 2,
	  linecap: 'round', //ignored by WebGLRenderer
	  linejoin:  'round' //ignored by WebGLRenderer
  } );
  materialFloor = new THREE.LineBasicMaterial( {
	  color: 0x000000, // 0xa0a0a0
	  linewidth: 2,
	  linecap: 'round', //ignored by WebGLRenderer
	  linejoin:  'round' //ignored by WebGLRenderer
  } );
  materialFaces = new THREE.MeshBasicMaterial( { color: 0xffffff, side: THREE.DoubleSide, transparent: true, opacity:0.75 } );
*/
}



function addRectangle(group,v1,v2,v3,v4,materialForFaces,materialForLines,showFaces)
{
  var geometry = new THREE.Geometry();
  geometry.vertices.push(new THREE.Vector3( v1[0], v1[1], v1[2] ));
  geometry.vertices.push(new THREE.Vector3( v2[0], v2[1], v2[2] ));
  geometry.vertices.push(new THREE.Vector3( v3[0], v3[1], v3[2] ));
  geometry.vertices.push(new THREE.Vector3( v4[0], v4[1], v4[2] ));
  geometry.vertices.push(new THREE.Vector3( v1[0], v1[1], v1[2] ));
  if (showFaces)
  {
    geometry.faces.push( new THREE.Face3( 0, 1, 2 ) );
    geometry.faces.push( new THREE.Face3( 2, 3, 4 ) );
/*
    geometry.computeFaceNormals();
    geometry.computeVertexNormals();
*/
    var meshfaces = new THREE.Mesh( geometry, materialForFaces );
    group.add( meshfaces );
  }
  var meshlines = new THREE.Line( geometry, materialForLines );
  group.add( meshlines );
}


function addCircle(group,center,rx,ry,materialLocalFaces, materialLocalLines,showFaces)
{
//console.log("ENTER addCircle");
  var geometryLines = new THREE.Geometry();
  var geometryFaces = new THREE.Geometry();
  var i;
  var nrsteps=24;

  for (i=0;i<=nrsteps;i++)
  {
    var angle = (i*2.0*Math.PI)/nrsteps;
    var cs = Math.cos(angle);
    var sn = Math.sin(angle);
    var x = center[0]+rx[0]*cs+ry[0]*sn;
    var y = center[1]+rx[1]*cs+ry[1]*sn;
    var z = center[2]+rx[2]*cs+ry[2]*sn;
    geometryLines.vertices.push(new THREE.Vector3( x, y, z ));
    if (showFaces) geometryFaces.vertices.push(new THREE.Vector3( x, y, z ));
  }
  if (showFaces)
  {
    for (i=1;i<nrsteps-1;i++)
    {
      geometryFaces.faces.push( new THREE.Face3( 0, i, i+1 ) );
    }
    var meshfaces = new THREE.Mesh( geometryFaces, materialLocalFaces );
    group.add( meshfaces );
  }
  var meshlines = new THREE.Line( geometryLines, materialLocalLines );
  group.add( meshlines );
}


function addCylinder(group,center,rx,ry,height,materialForFaces,materialForLines,showFaces)
{
//console.log("ENTER addCylinder");
  addCircle(group,center,rx,ry, materialForFaces, materialForLines, showFaces && (materialForFaces != null));

  var cross = [0,0,0];
  cross[0] = rx[1]*ry[2]-rx[2]*ry[1];
  cross[1] = rx[2]*ry[0]-rx[0]*ry[2];
  cross[2] = rx[0]*ry[1]-rx[1]*ry[0];

  var length = Math.sqrt(cross[0]*cross[0]+
                         cross[1]*cross[1]+
			 cross[2]*cross[2]);

  cross[0] /= length;
  cross[1] /= length;
  cross[2] /= length;

  cross[0] *= height;
  cross[1] *= height;
  cross[2] *= height;

  addCircle(group,[center[0]+cross[0],center[1]+cross[1],center[2]+cross[2]],
    rx,ry, materialForFaces, materialForLines, showFaces && (materialForFaces != null));
  
  addRectangle(group,[center[0]-rx[0],center[1]-rx[1],center[2]-rx[2]],
    [center[0]+rx[0],center[1]+rx[1],center[2]+rx[2]],
    [center[0]+cross[0]+rx[0],center[1]+cross[1]+rx[1],center[2]+cross[2]+rx[2]],
    [center[0]+cross[0]-rx[0],center[1]+cross[1]-rx[1],center[2]+cross[2]-rx[2]], 
    materialForFaces, materialForLines, false);

  addRectangle(group,[center[0]-ry[0],center[1]-ry[1],center[2]-ry[2]],
    [center[0]+ry[0],center[1]+ry[1],center[2]+ry[2]],
    [center[0]+cross[0]+ry[0],center[1]+cross[1]+ry[1],center[2]+cross[2]+ry[2]],
    [center[0]+cross[0]-ry[0],center[1]+cross[1]-ry[1],center[2]+cross[2]-ry[2]], 
    materialForFaces, materialForLines, false);
}


function addCylinder2(group,center,rx,ry,height,materialForCap,materialForTube,materialForLines,showFaces)
{

  var cross = [0,0,0];
  cross[0] = rx[1]*ry[2]-rx[2]*ry[1];
  cross[1] = rx[2]*ry[0]-rx[0]*ry[2];
  cross[2] = rx[0]*ry[1]-rx[1]*ry[0];

  var length = Math.sqrt(cross[0]*cross[0]+
                         cross[1]*cross[1]+
			 cross[2]*cross[2]);

  cross[0] /= length;
  cross[1] /= length;
  cross[2] /= length;

  cross[0] *= height;
  cross[1] *= height;
  cross[2] *= height;


//console.log("ENTER addCircle");
  var geometryLines0 = new THREE.Geometry();
  var geometryLines1 = new THREE.Geometry();
  var geometryCap = new THREE.Geometry();
  var geometryTube = new THREE.Geometry();
  var i;
  var nrsteps=24;

  for (i=0;i<=nrsteps;i++)
  {
    var angle = (i*2.0*Math.PI)/nrsteps;
    var cs = Math.cos(angle);
    var sn = Math.sin(angle);
    var x = center[0]+rx[0]*cs+ry[0]*sn;
    var y = center[1]+rx[1]*cs+ry[1]*sn;
    var z = center[2]+rx[2]*cs+ry[2]*sn;
    geometryLines0.vertices.push(new THREE.Vector3( x, y, z ));
    geometryCap   .vertices.push(new THREE.Vector3( x, y, z ));
    geometryTube  .vertices.push(new THREE.Vector3( x, y, z ));

    x += cross[0];
    y += cross[1];
    z += cross[2];

    geometryLines1.vertices.push(new THREE.Vector3( x, y, z ));
    geometryCap   .vertices.push(new THREE.Vector3( x, y, z ));
    geometryTube  .vertices.push(new THREE.Vector3( x, y, z ));
  }
  if (showFaces)
  {
    if (materialForCap != null)
    {
      for (i=1;i<nrsteps-1;i++)
      {
	geometryCap.faces.push( new THREE.Face3( 0, 2*i, 2*i+2 ) );
	geometryCap.faces.push( new THREE.Face3( 1, 2*i+1, 2*i+3 ) );
      }
    }
    for (i=0;i<nrsteps;i++)
    {
      geometryTube.faces.push( new THREE.Face3( 2*i, 2*i+1, 2*i+2 ) );
      geometryTube.faces.push( new THREE.Face3( 2*i+1, 2*i+2, 2*i+3 ) );
    }
    if (materialForCap!=null)
    {
      var meshfaces = new THREE.Mesh( geometryCap, materialForCap );
      group.add( meshfaces );
    }
    if (materialForTube!=null)
    {
      var meshtube = new THREE.Mesh( geometryTube, materialForTube );
      group.add( meshtube );
    }
  }
  if (materialForLines!=null)
  {
    var meshlines = new THREE.Line( geometryLines0, materialForLines );
    group.add( meshlines );
    meshlines = new THREE.Line( geometryLines1, materialForLines );
    group.add( meshlines );
  }
}









function addCylinderLines2(group,center,rx,ry,height,materialForLines)
{
  var cross = [0,0,0];
  cross[0] = rx[1]*ry[2]-rx[2]*ry[1];
  cross[1] = rx[2]*ry[0]-rx[0]*ry[2];
  cross[2] = rx[0]*ry[1]-rx[1]*ry[0];

  var length = Math.sqrt(cross[0]*cross[0]+
                         cross[1]*cross[1]+
			 cross[2]*cross[2]);


  var rxlen=Math.sqrt(rx[0]*rx[0]+rx[1]*rx[1]+rx[2]*rx[2]);

  var nrmidsteps=Math.floor(height/rxlen);
  var midstepdelta=height/nrmidsteps;

  cross[0] /= length;
  cross[1] /= length;
  cross[2] /= length;

  var midstepdelta=[cross[0]*midstepdelta,cross[1]*midstepdelta,cross[2]*midstepdelta];

  cross[0] *= height;
  cross[1] *= height;
  cross[2] *= height;
 

//console.log("ENTER addCircle");
  var geometryLines0 = new THREE.Geometry();
  var geometryLines1 = new THREE.Geometry();
  var midsteps=[];

  var i;
  var j;
  for (j=0;j<nrmidsteps;j++)
  {
    midsteps[j]=new THREE.Geometry();
  }

  var nrsteps=24;

  for (i=0;i<=nrsteps;i++)
  {
    var angle = (i*2.0*Math.PI)/nrsteps;
    var cs = Math.cos(angle);
    var sn = Math.sin(angle);
    var x = center[0]+rx[0]*cs+ry[0]*sn;
    var y = center[1]+rx[1]*cs+ry[1]*sn;
    var z = center[2]+rx[2]*cs+ry[2]*sn;
    geometryLines0.vertices.push(new THREE.Vector3( x, y, z ));
    var geometryTube = new THREE.Geometry();
    geometryTube  .vertices.push(new THREE.Vector3( x, y, z ));

    for (j=1;j<=nrmidsteps;j++)
    {
      midsteps[j-1].vertices.push(new THREE.Vector3( x+j*midstepdelta[0], y+j*midstepdelta[1], z+j*midstepdelta[2] ));
    }


    x += cross[0];
    y += cross[1];
    z += cross[2];

    geometryLines1.vertices.push(new THREE.Vector3( x, y, z ));
    geometryTube  .vertices.push(new THREE.Vector3( x, y, z ));
    var meshtube = new THREE.Line( geometryTube, materialForLines );
    group.add( meshtube );
  }
  if (materialForLines!=null)
  {
    for (j=0;j<nrmidsteps;j++)
    {
      var midlines = new THREE.Line( midsteps[j], materialForLines );
      group.add( midlines );
    }
    var meshlines = new THREE.Line( geometryLines0, materialForLines );
    group.add( meshlines );
    meshlines = new THREE.Line( geometryLines1, materialForLines );
    group.add( meshlines );
  }
}




















function cylinderGeometry(center,rx,ry,height,capscale,materialForFaces,materialForLines,sceneFaces,sceneLines)
{
  var cross = [0,0,0];
  cross[0] = rx[1]*ry[2]-rx[2]*ry[1];
  cross[1] = rx[2]*ry[0]-rx[0]*ry[2];
  cross[2] = rx[0]*ry[1]-rx[1]*ry[0];

  var length = Math.sqrt(cross[0]*cross[0]+
                         cross[1]*cross[1]+
			 cross[2]*cross[2]);


  var rxlen=Math.sqrt(rx[0]*rx[0]+rx[1]*rx[1]+rx[2]*rx[2]);

  var nrmidsteps=Math.floor(height/rxlen);
  var midstepdelta=height/nrmidsteps;

  cross[0] /= length;
  cross[1] /= length;
  cross[2] /= length;

  var midstepdelta=[cross[0]*midstepdelta,cross[1]*midstepdelta,cross[2]*midstepdelta];

  cross[0] *= height;
  cross[1] *= height;
  cross[2] *= height;

//console.log("ENTER addCircle");
  var geometryLines0 = new THREE.Geometry();
  var geometryLines1 = new THREE.Geometry();
  var geometryCap    = new THREE.Geometry();
  var geometryTube   = new THREE.Geometry();

  var midsteps=[];

  var i;
  var j;
  for (j=0;j<nrmidsteps;j++)
  {
    midsteps[j]=new THREE.Geometry();
  }

  var nrsteps=24;

  for (i=0;i<=nrsteps;i++)
  {
    var angle = (i*2.0*Math.PI)/nrsteps;
    var cs = Math.cos(angle);
    var sn = Math.sin(angle);
    var x = center[0]+rx[0]*cs+ry[0]*sn;
    var y = center[1]+rx[1]*cs+ry[1]*sn;
    var z = center[2]+rx[2]*cs+ry[2]*sn;
    geometryLines0.vertices.push(new THREE.Vector3( x, y, z ));
    geometryCap   .vertices.push(new THREE.Vector3( x, y, z ));
    geometryTube  .vertices.push(new THREE.Vector3( x, y, z ));

    var geometryTubeLines = new THREE.Geometry();
    geometryTubeLines  .vertices.push(new THREE.Vector3( x, y, z ));

    for (j=1;j<=nrmidsteps;j++)
    {
      var stepscale=capscale+(1-capscale)*((nrmidsteps-j)/(nrmidsteps+0.0));
      x = center[0]+stepscale*rx[0]*cs+stepscale*ry[0]*sn;
      y = center[1]+stepscale*rx[1]*cs+stepscale*ry[1]*sn;
      z = center[2]+stepscale*rx[2]*cs+stepscale*ry[2]*sn;

      midsteps[j-1].vertices.push(new THREE.Vector3( x+j*midstepdelta[0], y+j*midstepdelta[1], z+j*midstepdelta[2] ));
    }

    x = center[0]+capscale*rx[0]*cs+capscale*ry[0]*sn;
    y = center[1]+capscale*rx[1]*cs+capscale*ry[1]*sn;
    z = center[2]+capscale*rx[2]*cs+capscale*ry[2]*sn;
    x += cross[0];
    y += cross[1];
    z += cross[2];

    geometryLines1.vertices.push(new THREE.Vector3( x, y, z ));
    geometryCap   .vertices.push(new THREE.Vector3( x, y, z ));
    geometryTube  .vertices.push(new THREE.Vector3( x, y, z ));

    geometryTubeLines  .vertices.push(new THREE.Vector3( x, y, z ));
    var meshtube = new THREE.Line( geometryTubeLines, materialForLines );
    sceneLines.add( meshtube );
  }




  for (i=1;i<nrsteps-1;i++)
  {
    geometryCap.faces.push( new THREE.Face3( 0, 2*i, 2*i+2 ) );
    geometryCap.faces.push( new THREE.Face3( 1, 2*i+1, 2*i+3 ) );
  }

  for (i=0;i<nrsteps;i++)
  {
    geometryTube.faces.push( new THREE.Face3( 2*i, 2*i+1, 2*i+2 ) );
    geometryTube.faces.push( new THREE.Face3( 2*i+1, 2*i+2, 2*i+3 ) );
  }

  {
    var meshfaces = new THREE.Mesh( geometryCap, materialForFaces );
    sceneFaces.add( meshfaces );
  }

  {
    var meshtube = new THREE.Mesh( geometryTube, materialForFaces );
    sceneFaces.add( meshtube );
  }


  for (j=0;j<nrmidsteps;j++)
  {
    var midlines = new THREE.Line( midsteps[j], materialForLines );
    sceneLines.add( midlines );
  }
  var meshlines = new THREE.Line( geometryLines0, materialForLines );
  sceneLines.add( meshlines );
  meshlines = new THREE.Line( geometryLines1, materialForLines );
  sceneLines.add( meshlines );
}






















function sphereGeometry(center,rx,ry,rz,materialForFaces,materialForLines,sceneFaces,sceneLines)
{
  var geometryFaces = new THREE.Geometry();

  var geometryLatitude = [];

  var nrstepslong=24;
  var nrstepslat=24;
  var longit,latit;

  for (longit=0;longit<=nrstepslong;longit++)
  {
    geometryLatitude[longit] = new THREE.Geometry();
  }

  for (latit=0;latit<=nrstepslat/2;latit++)
  {
    var latitangle = ((-nrstepslat/4.0+latit)*2.0*Math.PI)/nrstepslat;
    var latit_cs = Math.cos(latitangle);
    var latit_sn = Math.sin(latitangle);

    var geometryLongitude = new THREE.Geometry();

    for (longit=0;longit<=nrstepslong;longit++)
    {
      var longitangle = (longit*2.0*Math.PI)/nrstepslong;
      var longit_cs = Math.cos(longitangle);
      var longit_sn = Math.sin(longitangle);

      var x = center[0]+rx[0]*longit_cs*latit_cs + ry[0]*longit_sn*latit_cs + rz[0]*latit_sn;
      var y = center[1]+rx[1]*longit_cs*latit_cs + ry[1]*longit_sn*latit_cs + rz[1]*latit_sn;
      var z = center[2]+rx[2]*longit_cs*latit_cs  +ry[2]*longit_sn*latit_cs + rz[2]*latit_sn;

      geometryLatitude[longit].vertices.push(new THREE.Vector3( x, y, z ));
      geometryLongitude.vertices.push(new THREE.Vector3( x, y, z ));

      geometryFaces.vertices.push(new THREE.Vector3( x, y, z ));
    }

    var meshtube = new THREE.Line( geometryLongitude, materialForLines );
    sceneLines.add( meshtube );
  }


  for (latit=0;latit<=nrstepslat/2;latit++)
  {
    var row=latit*(nrstepslong+1);
    for (longit=0;longit<nrstepslong;longit++)
    {
      geometryFaces.faces.push( new THREE.Face3( row+longit, row+longit+1, row+nrstepslong+1+longit+1 ) );
      geometryFaces.faces.push( new THREE.Face3( row+longit, row+nrstepslong+1+longit+1, row+nrstepslong+1+longit ) );
     
    }
  }
  {
    var meshtube = new THREE.Mesh( geometryFaces, materialForFaces );
    sceneFaces.add( meshtube );
  }
  
  for (longit=0;longit<=nrstepslong;longit++)
  {
    var meshtube = new THREE.Line( geometryLatitude[longit], materialForLines );
    sceneLines.add( meshtube );
  }
}















var triangulation = [];
var capSurface=0;


function bendDirection(shape,index, index2,index3, end)
{
  var v2=[];
  var v3=[];
  for (i=0;i<3;i++)
  {
    v2[i] = shape[index2][i]-shape[index][i];
    v3[i] = shape[index3][i]-shape[index][i];
  }
  return v2[1]*v3[0]-v2[0]*v3[1];  
}


function doTriangulate(shape, index, end)
{

//console.log("capSurface="+capSurface);

  //@@@ simple triangulation for convex polygons
  var index2=index+1;
  while (index2<end-1)
  {
    var index3=index2+1;

   while (index3 < (end-1) && capSurface*bendDirection(shape,index,index2,index3)<0)
   {
     index3++;
   }
   if (index3>index2+1)
   {
     doTriangulate(shape, index2, index3+1);
   }

//console.log(""+index2+": "+bendDirection(shape,index,index2,index3));    
    
    triangulation.push([ index, index2, index3 ]);
    index2 = index3;
  }
}


function organicGeometry(shape,trace,materialForFaces,materialForLinesThick,sceneFaces,sceneLines, longitudeModulo)
{
  var nrstepslong=shape.length;
  var nrstepslat=trace.length;

/*
  calculate the surface of the base shape now to ease triangulation later, positive value indicates clockwise, negative value counter-clockwise 
*/
  capSurface=0;
  var i;
  for (i=0;i<shape.length-1;i++)
  {
    var dx=shape[i+1][0]-shape[i][0];
    var avgy=(shape[i+1][1]+shape[i][1])/2.0;
    if (Math.abs(dx)>0.001)
    {
      capSurface+=dx*avgy;
    }
  }


  //@@@ simple triangulation for convex polygons
/*@@@TODO remove?
  triangulation = [];
  {
    var i;
    for (i=0;i<nrstepslong-1;i++)
    {
      triangulation[i] = [ 0, i, i+1 ];
    }
  }
*/

  // create the triangulation here.
  triangulation = [];
  doTriangulate(shape, 0, shape.length);


  var geometryFaces = new THREE.Geometry();

  var geometryLatitude = [];

  var longit,latit;

  for (longit=0;longit<nrstepslong;longit++)
  {
    geometryLatitude[longit] = new THREE.Geometry();
  }

  for (latit=0;latit<nrstepslat;latit++)
  {
    var normal=[1,0,0];
    if (latit==nrstepslat-1)
    {
      normal[0]=(trace[latit][0]-trace[latit-1][0]);
      normal[1]=(trace[latit][1]-trace[latit-1][1]);
      normal[2]=(trace[latit][2]-trace[latit-1][2]);
    }
    else
    {
      normal[0]=(trace[latit+1][0]-trace[latit][0]);
      normal[1]=(trace[latit+1][1]-trace[latit][1]);
      normal[2]=(trace[latit+1][2]-trace[latit][2]);
    }

    var nlen=Math.sqrt(normal[0]*normal[0]+normal[1]*normal[1]+normal[2]*normal[2]);
    normal[0]/=nlen;
    normal[1]/=nlen;
    normal[2]/=nlen;

    var normalx=[normal[2],-normal[0],0];

    // Otherwise the surface flips
    if (normal[2]<0)
    {
      normalx[0] = -normalx[0];
      normalx[1] = -normalx[1];
      normalx[2] = -normalx[2];
    }

//console.log("nx: "+normalx[0]+", "+normalx[1]+", "+normalx[2]);

//    var normalx=[0,-normal[0],normal[2]];

    var nxlen=Math.sqrt(normalx[0]*normalx[0]+normalx[1]*normalx[1]+normalx[2]*normalx[2]);


/*
   if (Math.abs(nxlen)<0.0001)
   {
     normalx=[0,normal[0],-normal[2]];
     nxlen=Math.sqrt(normalx[0]*normalx[0]+normalx[1]*normalx[1]+normalx[2]*normalx[2]);
   }
*/

   normalx[0] /= nxlen;
   normalx[1] /= nxlen;
   normalx[2] /= nxlen;


    var normaly=[normalx[1]*normal[2]-normalx[2]*normal[1],  normalx[2]*normal[0]-normalx[0]*normal[2]  ,normalx[0]*normal[1]-normalx[1]*normal[0]];

//    console.log("length nlen="+nlen);
//    console.log("length normalx="+Math.sqrt(normalx[0]*normalx[0]+normalx[1]*normalx[1]+normalx[2]*normalx[2]));
//    console.log("length normaly="+Math.sqrt(normaly[0]*normaly[0]+normaly[1]*normaly[1]+normaly[2]*normaly[2]));

//console.log("normal="+normal);
//console.log("normalx="+normalx);
//console.log("normaly="+normaly);

    var geometryCap=null;
    if (latit==0 || latit == nrstepslat-1)
    {
      geometryCap = new THREE.Geometry();
    }
    var geometryLongitude = new THREE.Geometry();

    var angle = (trace[latit][4]*Math.PI)/180.0;
    var cs = Math.cos(angle);
    var sn = Math.sin(angle);
    

    for (longit=0;longit<nrstepslong;longit++)
    {

      var x = shape[longit][0]*trace[latit][3];
      var y = shape[longit][1]*trace[latit][3];
      var z = shape[longit][2]*trace[latit][3];
      var xx=cs*x+sn*y;
      var yy=sn*x-cs*y;
      var zz=z;
      
      x=xx;
      y=yy;
      z=zz;


      var xx=x*normalx[0]+y*normaly[0]+z*normal[0];
      var yy=x*normalx[1]+y*normaly[1]+z*normal[1];
      var zz=x*normalx[2]+y*normaly[2]+z*normal[2];
      x=xx;
      y=yy;
      z=zz;

      
      x+=trace[latit][0];
      y+=trace[latit][1];
      z+=trace[latit][2];



/*
      var x = trace[latit][0]+shape[longit][0]*trace[latit][3];
      var y = trace[latit][1]+shape[longit][1]*trace[latit][3];
      var z = trace[latit][2]+shape[longit][2]*trace[latit][3];
*/

      geometryLatitude[longit].vertices.push(new THREE.Vector3( x, y, z ));
      geometryLongitude.vertices.push(new THREE.Vector3( x, y, z ));
      geometryFaces.vertices.push(new THREE.Vector3( x, y, z ));

      if (geometryCap != null)
      {
        geometryCap.vertices.push(new THREE.Vector3( x, y, z ));
      }
    }

    if (geometryCap != null)
    {
      var i;


      for (i=0;i<triangulation.length;i++)
      {
	geometryCap.faces.push( new THREE.Face3( triangulation[i][0], triangulation[i][1], triangulation[i][2] ) );
      }

/*@@@TODO remove old?
      for (i=0;i<nrstepslong-1;i++)
      {
	geometryCap.faces.push( new THREE.Face3( 0, i, i+1 ) );
      }
*/
      var meshtube = new THREE.Mesh( geometryCap, materialForFaces );
      sceneFaces.add( meshtube );
    }

//console.log("latit="+latit+", longitudeModulo="+longitudeModulo+", (latit%longitudeModulo)="+(latit%longitudeModulo));
//    if ((latit%longitudeModulo)==0 || (latit==0) || latit == nrstepslat-1)
    {
      var meshtube = new THREE.Line( geometryLongitude, materialForLines );
      sceneLines.add( meshtube );
    }
  }


  for (latit=0;latit<nrstepslat-1;latit++)
  {
    var row=latit*nrstepslong;
    for (longit=0;longit<nrstepslong-1;longit++)
    {
      geometryFaces.faces.push( new THREE.Face3( row+longit, row+longit+1, row+nrstepslong+longit+1 ) );
      geometryFaces.faces.push( new THREE.Face3( row+longit, row+nrstepslong+longit+1, row+nrstepslong+longit ) );
    }
  }
  {
    var meshtube = new THREE.Mesh( geometryFaces, materialForFaces );
    sceneFaces.add( meshtube );
  }
  
  for (longit=0;longit<nrstepslong;longit++)
  {
    var meshtube = new THREE.Line( geometryLatitude[longit], materialForLines );
    sceneLines.add( meshtube );
  }
}














function init()
{
  document.addEventListener( 'mousedown', onDocumentMouseDown, false );
  document.addEventListener( 'mousemove', onDocumentMouseMove, false );
  document.addEventListener( 'mouseup', onDocumentMouseUp, false );


  document.addEventListener( 'touchstart', onDocumentTouchStart, false );
  document.addEventListener( 'touchmove', onDocumentTouchMove, false );
  document.addEventListener( 'touchend', onDocumentTouchEnd, false );


  document.addEventListener( 'keypress', onDocumentKeyPress, false );
}

var mousedownSet = false;
var mouseXOnMouseDown;
var mouseYOnMouseDown;
var mouseX;
var mouseY;
var targetRotationXOnMouseDown;
var targetRotationYOnMouseDown;
var targetPositionXOnMouseDown;
var targetPositionYOnMouseDown;
var targetPositionZOnMouseDown;
//var mousemode=0;


function onDocumentMouseDown( event )
{
  event.preventDefault();


/*
  mousemode=0;
  if (event.shiftKey)
  {
    mousemode=1;
  }

  if (event.ctrlKey)
  {
    mousemode=2;
  }
*/

  mousedownSet = true;
  mouseXOnMouseDown = event.clientX;
  mouseYOnMouseDown = event.clientY;
  targetRotationXOnMouseDown = sceneGroup.rotation.y;
  targetRotationYOnMouseDown = sceneGroup.rotation.x;
  targetPositionXOnMouseDown = sceneGroup.position.x;
  targetPositionYOnMouseDown = sceneGroup.position.y;
  targetPositionZOnMouseDown = sceneGroup.position.z;
}

function onDocumentMouseMove( event )
{
  if (mousedownSet)
  {
    mouseX = event.clientX;
    mouseY = event.clientY;
    switch (mousemode)
    {
    case 0:
      sceneGroup.rotation.y = targetRotationXOnMouseDown + ( mouseX - mouseXOnMouseDown ) * 0.02;
      sceneGroup.rotation.x = targetRotationYOnMouseDown + ( mouseY - mouseYOnMouseDown ) * 0.02;
      break;
    case 1:
      sceneGroup.position.z = targetPositionZOnMouseDown + ( mouseY - mouseYOnMouseDown ) * 0.02;
      break;
    case 2:
      sceneGroup.position.x = targetPositionXOnMouseDown + ( mouseX - mouseXOnMouseDown ) * 0.02;
      sceneGroup.position.y = targetPositionYOnMouseDown - ( mouseY - mouseYOnMouseDown ) * 0.02;
      break;
    }
    renderer.render(scene, camera);
  }
}

function onDocumentMouseUp( event )
{
  mousedownSet = false;
}




function onDocumentTouchStart( event )
{
  event.preventDefault();


/*
  mousemode=0;
  if (event.shiftKey)
  {
    mousemode=1;
  }

  if (event.ctrlKey)
  {
    mousemode=2;
  }
*/

  mousedownSet = true;
  mouseXOnMouseDown = event.touches[0].clientX;
  mouseYOnMouseDown = event.touches[0].clientY;
  targetRotationXOnMouseDown = sceneGroup.rotation.y;
  targetRotationYOnMouseDown = sceneGroup.rotation.x;
  targetPositionXOnMouseDown = sceneGroup.position.x;
  targetPositionYOnMouseDown = sceneGroup.position.y;
  targetPositionZOnMouseDown = sceneGroup.position.z;
}

function onDocumentTouchMove( event )
{
  window.scrollTo(0, 0);
  event.preventDefault();
  event.stopPropagation();

  if (mousedownSet)
  {
    mouseX = event.touches[0].clientX;
    mouseY = event.touches[0].clientY;
    switch (mousemode)
    {
    case 0:
      sceneGroup.rotation.y = targetRotationXOnMouseDown + ( mouseX - mouseXOnMouseDown ) * 0.02;
      sceneGroup.rotation.x = targetRotationYOnMouseDown + ( mouseY - mouseYOnMouseDown ) * 0.02;
      break;
    case 1:
      sceneGroup.position.z = targetPositionZOnMouseDown + ( mouseY - mouseYOnMouseDown ) * 0.02;
      break;
    case 2:
      sceneGroup.position.x = targetPositionXOnMouseDown + ( mouseX - mouseXOnMouseDown ) * 0.02;
      sceneGroup.position.y = targetPositionYOnMouseDown - ( mouseY - mouseYOnMouseDown ) * 0.02;
      break;
    }
    renderer.render(scene, camera);
  }
}

function onDocumentTouchEnd( event )
{
  mousedownSet = false;
}















function onDocumentKeyPress( event )
{
  var chCode = ('charCode' in event) ? event.charCode : event.keyCode;
  if (chCode == "s".charCodeAt(0) || chCode == "S".charCodeAt(0))
  {

    if (sceneGroup != null)
    {
      scene.remove(sceneGroup);
      sceneGroup=null;
    }
    cubeh=3-cubeh;
    changeView(); // renderScene();
    renderer.render(scene, camera);
  }
}






